----------------------------------------
-- Instruction Fetch & Decode Phase
----------------------------------------

-------------------------------------------------------------------------------
-- Notes
---- 2006.10.20 
------ portĂ݂Bsport܂邩B
------ SRAMƂ̊֘AƂlȂƁB
---- 2006.10.25
------ portӂ₵B
------ Ƃ֑M̐Ă݂B
------ SRAM֘A͑債člĂȂB
------ fetch̃^C~OƂȂẮHClockManager݂Ȃ̂ĂB
-------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_signed.all;

entity IFD is
  
  port (
    CLK : in std_logic_vector;          -- system clock
    REGAD_S, REGAD_T, REGAD_D : out std_logic_vector(6 downto 0);
                                        -- register address
    INST : in  std_logic_vector(31 downto 0);  -- Instruction
    NEXT_PC : out std_logic_vector(31 downto 0);  -- Next Fetch PC
    OPCODE : out std_logic_vector(4 downto 0);  -- operation code
    OPTYPE : out std_logic_vector(1 downto 0);  -- operation type
    NEXTPC : out std_logic_vector(19 downto 0);  -- next program counter
    FPUEX : out std_logic_vector));      -- if fpu ex. then '1'

end IFD;

architecture arc_IFD of IFD is
  signal NEXT_PC : std_logic_vector(19 downto 0);
  variable DELAY : std_logic_vector;
  
begin  -- arc_IFD

-- Reset
  -- SRAM,USB͂߂ɂB
  
  if CLK'event and CLK = '1' then
    OPTYPE <= INST(31 downto 30); 
    REGAD_D <= INST(29 downto 23);
    OPCODE <= INST(22 downto 18);
    REGAD_S <= INST(17 downto 11);
    if INST(18) = '0' then
      REGAD_T <= INST(10 downto 4);
    else
      -- immidiate
    end if;
-- FPUsALUns̔f
    
    -- delay肩ȂŕKvB
    NEXT_PC <= NEXT_PC + 1;
    NEXTPC <= NEXT_PC + 1;
  end if;
  

end arc_IFD;







